#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <omp.h>
#include <signal.h>
#include <unistd.h>

// Ejemplo de ordenación por método de la burbuja
//esquema para la entrada/salida, validación y toma de tiempos
//para el proyecto de Iniciación al paralelismo en módulos de FP
//Universidad de Murcia-Instituto de Enseñanza Secundaria Ingeniero de la Cierva, Murcia, 2014

void generar(double *x,int t)
//se generan t datos reales con valores entre -10 y 10
{
  int i;

  for(i=0;i<t;i++)
  {  
     x[i] =((1.*rand())/RAND_MAX)*20-10;
  }
}

void escribir(double *x,int t)
{
  int i;

  for(i=0;i<t;i++)
  {  
     printf("%.4lf ",x[i]);
  }
  printf("\n");
}

void escribirresult(double *a,int N,int salida)
{
  int i;

  for(i=0;i<N;i++)
  {
        if((i%salida)==0)
        {
          printf("%.4lf ",a[i]);
        }
  }
  printf("\n");
}

/*
c
c     mseconds - returns elapsed milliseconds since Jan 1st, 1970.
c
*/
long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000 + t.tv_usec/1000;
}

static void alarm_handler(int sig) {
  fprintf(stderr, "Time Limit Exceeded\n");
  abort();
}

extern void sec(double *datos,int t);

int main(int argc,char *argv[]) {
  int i;
  int n;
  double *datos;
  int cuantos,semilla,salida;
  long long ti,tf,tt=0;

//en este fichero se escribirá el tiempo de ejecución
  FILE *stats_file = fopen("stats", "w");

//se pone una alarma para limitar el tiempo de ejecución
  struct sigaction sact;
  sigemptyset(&sact.sa_mask);
  sact.sa_flags = 0;
  sact.sa_handler = alarm_handler;
  sigaction(SIGALRM, &sact, NULL);
//cuando pase de 60 segundos se abortará
  alarm(60);  /* time limit */
 
//lee el númnero de roblemas a resolver
    scanf("%d",&cuantos);

  for(i=0;i<cuantos;i++)
  {
      scanf("%d",&n);                   // Tamaño del array
      scanf("%d",&semilla);             // semilla para la generación aleatoria
      scanf("%d",&salida);                 // para escribir valores seleccionados de la solución

// Espacio para los datos
     datos = (double *)malloc(sizeof(double)*n);

      srand(semilla);
      generar(datos,n);

#ifdef DEBUG
      escribir(datos,n);
#endif
    ti=mseconds(); 
    sec(datos,n);

    tf=mseconds(); 

// El tiempo del primer caso no se incluye
      if(i!=0) tt+=tf-ti;
#ifdef DEBUG
// mientras se depura se escribe el tiempo de cada ejecución
      fprintf(stats_file, "%Ld\n", tf-ti);
#endif
// se escriben los resultados para todas las entradas
      escribirresult(datos,n,salida);
      free(datos);
  }
  
    fprintf(stats_file, "%Ld\n", tt);
    fclose(stats_file);
  return 0;
}
