/*
  CPP_CONTEST=PP-FP2014
  CPP_PROBLEM=A
  CPP_LANG=C+OPENMP
  CPP_PROCESSES_PER_NODE=saturno 1
*/

#include <stdlib.h>
#include <omp.h>
 
void ordenar(double *x,int t)
{
    int i,j;
    double temp;

    for(i=0;i<t;i++)
    {
        for(j=i+1;j<t;j++)
        {
             if(x[i]>x[j])
             {
                 temp=x[i];
                 x[i]=x[j];
                 x[j]=temp;
             }
         }
     }
}

//Se ha modificado la mezcla porque al usar más de dos hilos 
//hay que hacer varias mezclas en zonas distintas
void mezclar(double *x,int izq,int med,int der)
{
    int i,j,k;
    double *temp=(double *) malloc(sizeof(double)*(der-izq));

    i=izq;
    j=med;
    k=0;
    while(i<med && j<der)
    {
       if(x[i]<x[j])
       {
            temp[k]=x[i];
            i++;
       }
       else
       {
            temp[k]=x[j];
            j++;
       }
       k++;
    }
    for(;i<med;i++)
    {
         temp[k]=x[i];
         k++;
    }
    for(;j<der;j++)
    {
        temp[k]=x[j];
        k++;
    }
    for(i=0;i<der-izq;i++)
    {
        x[i+izq]=temp[i];
    }
    free(temp);
}

    
void  sec(double *datos,int n)
{
  int i;
  int NUM_THREADS=1;
//para la ejecución secuencial se pone en marcha un único hilo
  omp_set_num_threads(NUM_THREADS);

//el hilo maestro pone en marcha los esclavos
#pragma omp parallel 
{
//los hilos obtienen su identificador, que va de 0 a NUM_THREADS-1
    int nodo=omp_get_thread_num();
    if(nodo!=NUM_THREADS-1)
    {
//todos los hilos trabajan con la misma cantidad de datos
        ordenar(&datos[nodo*(n/NUM_THREADS)],n/NUM_THREADS);
    }
    else
    {
//salvo el último, que ordena todos los datos restantes
        ordenar(&datos[nodo*(n/NUM_THREADS)],n-nodo*(n/NUM_THREADS));
    }
}    
//La sincronización entre hilos se hace al salir de la región paralela
//a partir de aquí trabaja solo el hilo maestro

//El hilo maestro mezcla los trozos ordenados.
//Se podría hacer de forma más eficiente, mezclando cada vez trozos de tamaño similar,
//e incluso usando hilos distintos para mezclas distintas
   for(i=NUM_THREADS-2;i>=0;i--)
   {
       int izq=i*(n/NUM_THREADS);
       int med=izq+n/NUM_THREADS;
       mezclar(datos,izq,med,n);
   }
}

