// Ejemplo de ordenación con CUDA
//esquema para la entrada/salida, validación y toma de tiempos
//para el proyecto de Iniciación al paralelismo en módulos de FP
//Universidad de Murcia-Instituto de Enseñanza Secundaria Ingeniero de la Cierva, Murcia, 2014

#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <signal.h>
#include <unistd.h>

//#include <cutil_inline.h>

void sec(int n, int *a);

void initialize(int *m,int t,int maximo)
{
  int i;

// Integer numbers are generated randomly
  for(i=0;i<t*t;i++)
  {  
    m[i] =(int) (((1.*rand())/RAND_MAX)*maximo);
  }
}

void escribir(int *m, int t){
  int i, j;

  for (i = 0; i < t; i++)
  {
    for (j = 0; j < t; j++)
    {  
      printf("%d ",m[i*t+j]);
    }
    printf("\n");
  }
  printf("\n");
}

void escribirresult(int n,int *m, int stride){
  int i;

  for (i = 0; i < n*n; i+=stride)
  {
    printf("%d ",m[i]);
  }
  printf("\n");
}

/*
c
c     mseconds - returns elapsed milliseconds since Jan 1st, 1970.
c
*/
long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000 + t.tv_usec/1000;
}

static void alarm_handler(int sig) {
  fprintf(stderr, "Time Limit Exceeded\n");
  abort();
}









////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

int main(int argc,char *argv[]) {
  int i,N,cuantos,stride,semilla,maximo;
  long long ti,tf,tt=0.;
  int *a;

  FILE *stats_file = fopen("stats", "w");

  struct sigaction sact;
  sigemptyset(&sact.sa_mask);
  sact.sa_flags = 0;
  sact.sa_handler = alarm_handler;
  sigaction(SIGALRM, &sact, NULL);
  alarm(40);  /* time limit */


// The number of test cases is read
    scanf("%d",&cuantos);

  for(i=0;i<cuantos;i++)
  {
      scanf("%d",&N);                   // The first argument is the matrix size
      scanf("%d",&semilla);             // the second is the seed for random generation
      scanf("%d",&maximo);		// the maximum value of the ingeter; which will be generated between 0 and maximum-1
      scanf("%d",&stride);              // and the stride used to writte the solution

// Space for the matrix
      a = (int *) malloc(sizeof(int)*N*N);

      srand(semilla);
      initialize(a,N,maximo);

    ti=mseconds(); 
	sec(N,a);
    tf=mseconds(); 


// The time of the first problem is not considered
      if(i!=0) tt+=tf-ti;

// The results of each problem are written,
// even for the first problem
      
      escribirresult(N,a,stride);
      free(a);

  }//for cuantos
  
    fprintf(stats_file, "%Ld\n", tt);
    fclose(stats_file);

  return 0;
}
