// Ejemplo de multiplicación de matrices con CUDA: multiplicación de cuatro matrices
//esquema para la entrada/salida, validación y toma de tiempos
//para el proyecto de Iniciación al paralelismo en módulos de FP
//Universidad de Murcia-Instituto de Enseñanza Secundaria Ingeniero de la Cierva, Murcia, 2014

#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <omp.h>
#include <signal.h>
#include <unistd.h>

void initialize(double *m, int t){
  int i;

  for (i = 0; i < t*t; i++)
  {
    m[i] = (double)((int)(((1.*rand()/RAND_MAX)*2000.-1000.)))/100.;
  }
}

void escribir(double *m, int t){
  int i, j;

  for (i = 0; i < t; i++)
  {
    for (j = 0; j < t; j++)
    {  
      printf("%.8lf ",m[i*t+j]);
    }
    printf("\n");
  }
}

void escribirresult(double *m, int t,int cantidad){
  int i, j,cont=0;

  for (i = 0; i < t; i++)
  {
    for (j = 0; j < t; j++)
    {  
      if((int) (m[i*t+j]*1000.)!=0)
      {
        if((cont%cantidad)==0)
        {
          printf("%.0lf ",m[i*t+j]);
        }
        cont++;
      }
    }
    printf("\n");
  }
  printf("\n");
}

/*
c
c     mseconds - returns elapsed milliseconds since Jan 1st, 1970.
c
*/
long long mseconds(){
  struct timeval t;
  gettimeofday(&t, NULL);
  return t.tv_sec*1000 + t.tv_usec/1000;
}

static void alarm_handler(int sig) {
  fprintf(stderr, "Time Limit Exceeded\n");
  abort();
}

extern void sec(int,double *,double *,double *,double *,double*);

int main(int argc,char *argv[]) {
  int i, N,cuantos,semilla,cantidadescribir;
  long long ti,tf,tt=0;
  double *a,*b,*c,*d,*r;

  FILE *stats_file = fopen("stats", "w");

  struct sigaction sact;
  sigemptyset(&sact.sa_mask);
  sact.sa_flags = 0;
  sact.sa_handler = alarm_handler;
  sigaction(SIGALRM, &sact, NULL);
  alarm(60);  /* time limit */


    scanf("%d",&cuantos);
  for(i=0;i<cuantos;i++)
  {
      scanf("%d",&N);
      scanf("%d",&semilla);
      scanf("%d",&cantidadescribir);
      a = (double *) malloc(sizeof(double)*N*N);
      b = (double *) malloc(sizeof(double)*N*N);
      c = (double *) malloc(sizeof(double)*N*N);
      d = (double *) malloc(sizeof(double)*N*N);
      r = (double *) malloc(sizeof(double)*N*N);
      srand(semilla);
      initialize(a,N);
      initialize(b,N);
      initialize(c,N);
      initialize(d,N);
    ti=mseconds(); 
    sec(N,a,b,c,d,r);
    tf=mseconds(); 
      if(i!=0) tt+=tf-ti;
      escribirresult(r,N,cantidadescribir);
      free(a);
      free(b);
      free(c);
      free(d);
      free(r);
  }
  
    fprintf(stats_file, "%Ld\n", tt);
  return 0;
}
