/*
  CPP_CONTEST=2013Cal-2011
  CPP_PROBLEM=O
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=marte 1
*/

// 

/*RECORD in the new system
with the GForce in mercurio.
Provided by the Organization of the contest
time 434
speed-up 45.16
*/


#include <stdlib.h>
#include <omp.h>
#include <stdio.h>
#include <helper_functions.h>
#include <helper_cuda.h>

////////////////////////////////////////////////////////////////////////////////

__global__ void kernel_mm2(int t,double *a_GPU,double *b_GPU,double *r_GPU)
{ 


  	//global ID
	unsigned int
		k,
     		j = blockDim.x * blockIdx.x + threadIdx.x,
	     	i = blockDim.y * blockIdx.y + threadIdx.y;
	double	aux;
	
	if (i<t && j<t)
	{

		aux=0.;
		for(k=0;k<t;k++)
		{
			aux+=a_GPU[i*t+k]*b_GPU[k*t+j];	
		}
		r_GPU[i*t+j]=aux;
	}
	__syncthreads();
}

///////////////////////////////////////////////////////////////////////////////////////


void sec(int t,double *a,double *b,double *c,double *d,double *r)
{
  double *temp=(double *) malloc(sizeof(double)*t*t);


 double     *a_GPU,*b_GPU,*c_GPU,*d_GPU,*r_GPU,*temp_GPU;

  unsigned int     nPos, nBytes;


  dim3     ThreadsPerBlock,     BlocksPerGrid;


  //some common initializations
  nPos  =t*t;
  nBytes=nPos*sizeof(double);
  
  //setup GPU execution parameters, You can modify
  ThreadsPerBlock.x = 4;
  ThreadsPerBlock.y = 4;
  ThreadsPerBlock.z = 1;

  BlocksPerGrid.x = (t + ThreadsPerBlock.x - 1) / ThreadsPerBlock.x;
  BlocksPerGrid.y = (t + ThreadsPerBlock.y - 1) / ThreadsPerBlock.y;

  //allocate device memory
  checkCudaErrors(cudaMalloc((void **)&a_GPU, nBytes));
  checkCudaErrors(cudaMalloc((void **)&b_GPU, nBytes));
  checkCudaErrors(cudaMalloc((void **)&c_GPU, nBytes));
  checkCudaErrors(cudaMalloc((void **)&d_GPU, nBytes));
  checkCudaErrors(cudaMalloc((void **)&r_GPU, nBytes));
  checkCudaErrors(cudaMalloc((void **)&temp_GPU, nBytes));

  //copy data from host memory to device memory
  checkCudaErrors(cudaMemcpy(a_GPU, a, nBytes, cudaMemcpyHostToDevice));
  checkCudaErrors(cudaMemcpy(b_GPU, b, nBytes, cudaMemcpyHostToDevice));
  checkCudaErrors(cudaMemcpy(c_GPU, c, nBytes, cudaMemcpyHostToDevice));
  checkCudaErrors(cudaMemcpy(d_GPU, d, nBytes, cudaMemcpyHostToDevice));





   kernel_mm2<<<BlocksPerGrid, ThreadsPerBlock>>>(t, a_GPU, b_GPU, temp_GPU);
   kernel_mm2<<<BlocksPerGrid, ThreadsPerBlock>>>(t, temp_GPU, c_GPU, a_GPU);
   kernel_mm2<<<BlocksPerGrid, ThreadsPerBlock>>>(t, a_GPU, d_GPU, r_GPU);







//wait for thread completion
  cudaThreadSynchronize();
    
  //check if kernel execution generated any error
  //cutilCheckMsg("kernel execution failed");


  //copy data from device memory to host memory
     checkCudaErrors(cudaMemcpy(r, r_GPU, nBytes, cudaMemcpyDeviceToHost));

  // free device Memory
  checkCudaErrors(cudaFree((void *) a_GPU));
  checkCudaErrors(cudaFree((void *) b_GPU));
  checkCudaErrors(cudaFree((void *) c_GPU));
  checkCudaErrors(cudaFree((void *) d_GPU));
  checkCudaErrors(cudaFree((void *) r_GPU));
  checkCudaErrors(cudaFree((void *) temp_GPU));

  cudaThreadExit();

  #ifdef DEBUG
     // While debugging the matrix and the numbers are written
     escribir(r_CPU,Size);
  #endif




}//function mm()









