/*
  CPP_CONTEST=2013Cal-2012
  CPP_PROBLEM=G
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=marte 1
*/

//

/* RECORD
Juan Mompeán Esteban
student of Methodology of Parallel programming
at the University of Murcia
OpenMP+CUDA
January 30, 2013
time 1419 msec
speed-up 2,2
it does not improve the record, but is included in the table because is the first implementation using CUDA
*/

/*RECORD in the new system
when the programs in the record table are run in the new system
in the gpu in marte or mercurio,
it is the absolute record, with
time 2866 msec
speed-up 7.85
*/

#include <stdlib.h>
#include <stdio.h>
#include <helper_functions.h>
#include <helper_cuda.h>
#include <math.h>

#define BLOCKSIZE 32

__global__ void radixsort(int *a, int *b, int n)
{
  int i, m, exp = 1;
  __shared__ int shared[10 * BLOCKSIZE];
  // Coge su trozo de memoria compartida
  int *bucket = &shared[10 * threadIdx.x];
  // Si está fuera de la matriz termina
  if (((blockDim.x * blockIdx.x) + threadIdx.x) >= n) {
	  return;
  }
  // Busca la fila que le toca a este hilo
  b = &b[n * ((blockDim.x * blockIdx.x) + threadIdx.x)];
  a = &a[n * ((blockDim.x * blockIdx.x) + threadIdx.x)];

  m = a[0];
  for (i = 0; i < n; i++)
  {
	m = max(a[i], m);
  }
 
  for (;(m / exp) > 0; exp *= 10)
  {
	for (i = 0; i < 10; i++) {
		bucket[i] = 0;
	}
	for (i = 0; i < n; i++) {
		bucket[(a[i] / exp) % 10]++;
	}
	for (i = 1; i < 10; i++) {
		bucket[i] += bucket[i - 1];
	}
	for (i = n - 1; i >= 0; i--) {
		b[--bucket[(a[i] / exp) % 10]] = a[i];
	}
	for (i = 0; i < n; i++) {
		a[i] = b[i];
	}
  }
}

__global__ void transponer(int *destino, int *origen, int n) {
	int i, fila;
	fila = (blockDim.x * blockIdx.x) + threadIdx.x;
	if (fila >= n) {
		return;
	}
	for (i = 0; i < n; i++) {
		destino[fila * n + i] = origen[i * n + fila];
	}
}
 
void sec(int t,int *a)
{
	int *d_a;
	cudaMalloc((void**)&d_a, 2 * sizeof(int) * t * t);
	cudaMemcpy(d_a, a, sizeof(int) * t * t, cudaMemcpyHostToDevice);
	cudaMemcpy(&d_a[t * t], d_a, sizeof(int) * t * t, cudaMemcpyDeviceToDevice);
	dim3 grid(ceil(t/(BLOCKSIZE * 1.0)));
	dim3 block(BLOCKSIZE);
	radixsort<<<grid, block>>>(d_a, &d_a[t * t], t);
	cudaThreadSynchronize();
	transponer<<<grid, block>>>(d_a, &d_a[t * t], t);
	cudaThreadSynchronize();
	cudaMemcpy(&d_a[t * t], d_a, sizeof(int) * t * t, cudaMemcpyDeviceToDevice);
	radixsort<<<grid, block>>>(d_a, &d_a[t * t], t);
	cudaThreadSynchronize();
	transponer<<<grid, block>>>(d_a, &d_a[t * t], t);
	cudaThreadSynchronize();
	// El resultado está en b
	cudaMemcpy(a, d_a, sizeof(int) * t * t, cudaMemcpyDeviceToHost);
	cudaFree(d_a);
}
