//Proyecto de Iniciación a la programación paralela en los módulos de informática
//Universidad de Murcia - Instituto de Enseñanza Secundaria Ingeniero de la Cerva, Murcia
//2014

//Ejemplo de paralelismo en Java
//Ordenación utilizando dos hilos

//En linux, 
//compilar con: javac ejemplojava.java
//ejecutar con: java ejemplojava n
//donde n es el número de datos que se quiere ordenar

import java.io.*;

//El nombre de la clase y del fichero es el mismo
public class ejemplojava {

//se utilizan variables globales a la clase para facilitar el acceso a ellos por los dos threads
    private static int n;
    private static float[]  datos;

    public static void generar(float x[],int t)
    //se generan t datos reales con valores entre -10 y 10
    {
         int i;

         for(i=0;i<t;i++)
        {  
            x[i] =-10 + (float)Math.random() * 20;
        }
    }

    public static void copiar(float x[],float y[],int t)
    {
        int i;
    
        for(i=0;i<t;i++)
        {
            y[i]=x[i];
        }
    }

    public static void escribir(float x[],int t)
   {
       int i;

       for(i=0;i<t;i++)
       {  
            System.out.format("%f ",x[i]); 
       }
      System.out.format("\n"); 
   }

//Se pasan los índices izquierdo y derecho porque se van a utilizar las variables globales
   public static void ordenar(float x[],int izq,int der)
  {
      int i,j;
      float temp;

      for(i=izq;i<der;i++)
      {
          for(j=i+1;j<der;j++)
          {
               if(x[i]>x[j])
               {
                   temp=x[i];
                   x[i]=x[j];
                   x[j]=temp;
               }
           }
       }
    }

    private static void mezclar(float x[],int t)
   {
        int i,j,k;
        float[] temp=new float[t];

        i=0;
        j=t/2;
        k=0;
        while(i<t/2 && j<t)
        {
            if(x[i]<x[j])
           {
               temp[k]=x[i];
               i++;
           }
          else
          {
               temp[k]=x[j];
               j++;
          }
          k++;
      }
     for(;i<t/2;i++)
    {
         temp[k]=x[i];
         k++;
    }
    for(;j<t;j++)
    {
        temp[k]=x[j];
        k++;
    }
    for(i=0;i<t;i++)
    {
        x[i]=temp[i];
    }
 }
    
    private static float comparar(float x[],float y[],int t)
   {
       int i;
       float total=0;

       for(i=0;i<t;i++)
      {
           total=(y[i]>x[i]?y[i]-x[i]:x[i]-y[i]);
      }
      return total;
   }
   
//Se llamará a un hilo de esta clase para llamar a la ordenación de la segunda mitad del array
   private static class threadordenar
        implements Runnable {
        public void run() {
             ordenar(datos,n/2,n);
        }
    }

    public static void main(String args[])
    {
//La entrada del número de datos se hace como argumento
        n=Integer.parseInt(args[0]);
       
        datos=new float[n];
        float[] copiadatos=new float[n];
        long ti,tf;

        generar(datos,n);
        copiar(datos,copiadatos,n);

//Si se quiere escribir los datos hay que quitar los comentarios de las líneas correspondientes
//        escribir(datos,n);
//        escribir(copiadatos,n);

        ti = System.currentTimeMillis();
        ordenar(copiadatos,0,n);
        tf= System.currentTimeMillis()-ti;
    
        System.out.format("Tiempo secuencial: %d microsegundos\n",tf);
//        escribir(copiadatos,n);

        ti = System.currentTimeMillis();
//Se declara el hilo y se pone en marcha
        Thread t = new Thread(new threadordenar());
        t.start();
        ordenar(datos,0,n/2);
//mientras el hilo esclavo está activo se espera
        while(t.isAlive());
        mezclar(datos,n);
        tf= System.currentTimeMillis()-ti;
        System.out.format("Tiempo paralelo: %d microsegundos\n",tf);
//        escribir(datos,n);
        System.out.format("Diferencia: %f\n",comparar(datos,copiadatos,n));
    }
}


